;*************************************************
;**						**
;**		 0010-01 V2.3	**			
;**						**
;*************************************************
; 10010100
; 11011001

.include "m16def.inc"

.DEF FLAG_PRIEM=R3
.DEF IN_NUM3=R5
.DEF IN_NUM2=R6
.DEF ZAGL=R10

.DEF A=R16
.DEF B=R17
.DEF C=R18

.DEF IN_NUM2=R21
.DEF IN_NUM3=R22

.DEF BUF=R24
.DEF BUF1=R25


; 26-27 - X

.DEF IN_NUM=R29

; 30-31 - Z

;*********************
.EQU TL0=$60
.EQU TL1=$61
.EQU TL2=$62
.EQU TL3=$63

;*********************

.EQU TH0=$64
.EQU TH1=$65
.EQU TH2=$66
.EQU TH3=$67

;*********************

.ORG $0
.ORG $0
	rjmp RESET ; Reset Handler
	RETI
	rjmp EXT_INT0 ; IRQ0 Handler
	RETI
	Rjmp EXT_INT1 ; IRQ1 Handler
	RETI
	RETI; jmp TIM2_COMP ; Timer2 Compare Handler
	RETI
	RETI; jmp TIM2_OVF ; Timer2 Overflow Handler
	RETI
	RETI; rjmp TIM1_CAPT ; Timer1 Capture Handler
	RETI
	RETI; rjmp TIM1_COMPA ; Timer1 CompareA Handler
	RETI
	RETI; rjmp TIM1_COMPB ; Timer1 CompareB Handler
	RETI
	rjmp TIM1_OVF ; Timer1 Overflow Handler
	RETI
	rjmp TIM0_OVF ; Timer0 Overflow Handler
	RETI
	RETI; rjmp SPI_STC ; SPI Transfer Complete Handler
	RETI
	RETI; rjmp USART_RXC ; USART RX Complete Handler
	RETI
	RETI; rjmp USART_UDRE ; UDR Empty Handler
	RETI
	RETI; rjmp USART_TXC ; USART TX Complete Handler
	RETI
	RETI; rjmp ADC ; ADC Conversion Complete Handler
	RETI
	RETI; rjmp EE_RDY ; EEPROM Ready Handler
	RETI
	RETI; rjmp ANA_COMP ; Analog Comparator Handler
	RETI
	rjmp TWSI ; Two-wire Serial Interface Handler
	RETI
	RETI; rjmp EXT_INT2 ; IRQ2 Handler
	RETI
	RETI; rjmp TIM0_COMP ; Timer0 Compare Handler
	RETI
	RETI; rjmp SPM_RDY ; Store Program Memory Ready Handler
	RETI

;*********************
;	"10"
.DB	"KLAVA-161-"

;****************************
;  TIMER0 INTERRUPT
;
;  TIM0..1	; 1=2mS
;
;    LOW_TIMER
;
;
TIM0_OVF:PUSH	BUF
	IN	BUF,SREG
	PUSH	BUF

	LDI	XL,$60
	CLR	XH

TMR0:	LD	BUF,X
	CPI	BUF,$FF
	BREQ	TMR1
	INC	BUF
	ST	X,BUF

TMR1:	LD	BUF,X+
	CPI	XL,$64
	BREQ	RETIME
	RJMP	TMR0

RETIME:
	POP	BUF
	OUT	SREG,BUF
	POP	BUF
	SEI
	RETI
	
;****************************
;  TIMER1 INTERRUPT	
;
;  TIMR0..1	;1=2Sec
;
;	HI_TIMER
;
TIM1_OVF:PUSH	BUF
	IN	BUF,SREG
	PUSH	BUF

	LDI	XL,$64
	CLR	XH

TMER0:	LD	BUF,X
	CPI	BUF,$FF
	BREQ	TMER1
	INC	BUF
	ST	X,BUF

TMER1:	LD	BUF,X+		; INC X
	CPI	XL,$68
	BREQ	RETIME1
	RJMP	TMER0

RETIME1:
	POP	BUF
	OUT	SREG,BUF
	POP	BUF
	SEI
	RETI

;*********************************************

WAIT1S:	CLR	A
	STS	TH0,A
WP1:	LDS	A,TH0
	CPI	A,2		; PAUSE 1S
	BRLO	WP1
	RET

;*********************************************
TWSI:
	RETI

;*********************************************
;           Ȩ   INT1!
;
EXT_INT1:
	RETI

;***************************************************
;           Ȩ   INT0! (KLAVA-CLOCK)
;

EXT_INT0: 
	CLI

	LDI	C,8

	SBIC	PIND,2	; 	CL=0
	RJMP	PRIM_END

	CLR	IN_NUM		; RESULT=0
	CLR	IN_NUM2
	CLR	IN_NUM3

	CLR	BUF1
	SBI	PORTD,0		; LED
	OUT	TCNT1L,BUF1
PRIM1:	SBIC	PIND,2		; CL=0
	RJMP	PRIM2	
	IN	BUF1,TCNT1L	;CL=0
	CPI	BUF1,100
	BRLO	PRIM1
	RJMP	PRIM_END

PRIM2:	CLR	BUF1		; CL=1
	CBI	PORTD,0		; LED
	OUT	TCNT1L,BUF1

PRIM3:	SBIS	PIND,2
	RJMP	PRIM4	; 
	IN	BUF1,TCNT1L	; CL=1
	CPI	BUF1,100
	BRLO	PRIM3
	RJMP	PRIM_END

PRIM4:	CLR	BUF1		; CL=0
	SBI	PORTD,0		; LED
	OUT	TCNT1L,BUF1

PRIM5:	SBIC	PIND,2	; 1?
	RJMP	PRIM6	; DA
	IN	BUF1,TCNT1L	; CL=0
	CPI	BUF1,100
	BRLO	PRIM5
	RJMP	PRIM_END

PRIM6:	CBI	PORTD,0		; LED
	SBIC	PIND,1		; CL=1
	SBR	IN_NUM,0b10000000

	DEC	C
	BREQ	IR2

	LSR	IN_NUM		; RIGHT SHIFT RESULT

	CLR	BUF1		; CL=1
	CBI	PORTD,0		; LED
	OUT	TCNT1L,BUF1
PRIM7:	SBIS	PIND,2	
	RJMP	PRIM4	
	IN	BUF1,TCNT1L
	CPI	BUF1,100
	BRSH	PRIM_END
	RJMP	PRIM7

	CLR	BUF1		; CL=0
	OUT	TCNT1L,BUF1
IR2:	IN	BUF1,TCNT1L
	CPI	BUF1,100
	BRSH	PRIM_END
	SBIC	PIND,2	; 0?
	RJMP	IR2
	SBI	PORTD,0		; LED
	CLR	BUF1		; CL=0
	OUT	TCNT1L,BUF1
IR3:	IN	BUF1,TCNT1L
	CPI	BUF1,100
	BRSH	PRIM_END
	SBIS	PIND,2	; 1?
	RJMP	IR3
	CBI	PORTD,0		; LED
	CLR	BUF1		; CL=0
	OUT	TCNT1L,BUF1
IR4:	IN	BUF1,TCNT1L
	CPI	BUF1,100
	BRSH	PRIM_END
	SBIC	PIND,2	; 0?
	RJMP	IR4
	SBI	PORTD,0		; LED
	CLR	BUF1		; CL=0
	OUT	TCNT1L,BUF1
IR5:	IN	BUF1,TCNT1L
	CPI	BUF1,100
	BRSH	PRIM_END
	SBIS	PIND,2	; 1?
	RJMP	IR5
	CBI	PORTD,0		; LED

	CLR	BUF1		; CL=1
	OUT	TCNT1L,BUF1
PRIM8:	SBIS	PIND,2
	RJMP	PRIM9
	IN	BUF1,TCNT1L	; CL=1
	CPI	BUF1,250
	BRLO	PRIM8

	CLR	BUF1		; CL=1
	OUT	TCNT1L,BUF1
PRIM81:	SBIS	PIND,2
	RJMP	PRIM9
	IN	BUF1,TCNT1L	; CL=1
	CPI	BUF1,250
	BRLO	PRIM81

	INC	FLAG_PRIEM
	LDI	BUF,0b00000000	;  -  INT0, INT1!
	OUT	GICR,BUF

PRIM_END: SEI	
	RETI

PRIM9:	MOV	IN_NUM3,IN_NUM2
	MOV	IN_NUM2,IN_NUM

	LDI	C,8

	CLR	IN_NUM		; RESULT=0
	CLR	BUF1
	SBI	PORTD,0		; LED
	OUT	TCNT1L,BUF1

	RJMP	PRIM1

WAITMM:	CLR	BUF1	
	OUT	TCNT1L,BUF1
WAITM1:	IN	BUF1,TCNT1L
	CPI	BUF1,50
	BRLO	WAITM1
	RET

BITS: 	RCALL	WAITMM
	RCALL	WAITMM
	RCALL	WAITMM
	RCALL	WAITMM
	RCALL	WAITMM
	RCALL	WAITMM
	RCALL	WAITMM
	CBI	PORTB,6
	RCALL	WAITMM
	SBI	PORTB,6
	RET

;*********************************************
;		RESET
;
RESET:
	ldi r16,high(RAMEND)	; Main program start
	out SPH,r16		; Set stack pointer to top of RAM
	ldi r16,low(RAMEND)
	out SPL,r16

	LDI	BUF,0b11000000	;  -  INT0, INT1!
	OUT	GICR,BUF
	LDI	BUF,0b00000101	; - 
	OUT	TIMSK,BUF
	LDI	BUF,0b00000011	;  - 
	OUT	TCCR0,BUF	;	1=2mS
	LDI	BUF,0b00000000	;  - 
	OUT	TCCR1A,BUF	;
	LDI	BUF,0b00000011	;  - 
	OUT	TCCR1B,BUF	;	1=0.5 S
;       LDI	BUF,0b00011111	;  - WDT ENABLE
;	OUT	WDTCR,BUF
       LDI	BUF,0b00010111	;  - WDT DISABLE
	OUT	WDTCR,BUF
       LDI	BUF,0b00001010	;  -  + FALLING INT0, FALLING INT1
	OUT	MCUCR,BUF
       LDI	BUF,0b10000000	;  - 
	OUT	MCUCSR,BUF

       LDI	BUF,0b00000000	; 0-INP 1-OUT
	OUT	DDRA,BUF	;  - PORTB
       LDI	BUF,0b11100000	; 0-INP 1-OUT
	OUT	DDRB,BUF	;  - PORTB
       LDI	BUF,0b00000000	; 0-INP 1-OUT
	OUT	DDRC,BUF	;  - PORTB
       LDI	BUF,0b00100001	;
	OUT	DDRD,BUF	;  - PORTD

;*********************************
;		MAIN
;*********************************

	SEI

	clr	buf
	OUT	PORTA,BUF
	OUT	PORTB,BUF
	OUT	PORTC,BUF
	OUT	PORTD,BUF
	CBI	PORTD,5		; STOP!

	INC	ZAGL

;	SBI	PORTD,0
;	RCALL	WAIT1S
;	CBI	PORTD,0

LOOP1:	LDS	BUF,TL3
	CPI	BUF,250		; 100mS TIMER
	BRLO	LOOP2

	LDI	BUF,0b00000000	; 0-INP 1-OUT
	OUT	DDRA,BUF	;  - PORTB
	LDI	BUF,0b11100000	; 0-INP 1-OUT
	OUT	DDRB,BUF	;  - PORTB
	LDI	BUF,0b00000000	; 0-INP 1-OUT
	OUT	DDRC,BUF	;  - PORTB
	LDI	BUF,0b00100001	;
	OUT	DDRD,BUF	;  - PORTD
	clr	buf
	OUT	PORTA,BUF
	OUT	PORTB,BUF
	OUT	PORTC,BUF
	OUT	PORTD,BUF
	CBI	PORTD,5		; STOP!

LOOP2:
; -------  JOYSTICK -----------
	SBI	PORTB,6		; SRCKL
	SBI	PORTB,7		; START
	RCALL	WAITMM
	CBI	PORTB,7

	RCALL	BITS	;1
	RCALL	BITS	;2
	RCALL	BITS	;3
	RCALL	BITS	;4
	RCALL	BITS	;5
	RCALL	BITS	;6
	RCALL	BITS	;7
	RCALL	BITS	;8

	RCALL	WAITMM
	SBI	PORTB,5		; RCLK
	RCALL	WAITMM
	CBI	PORTB,5		; RCLK
	RCALL	WAITMM

; -------  END JOYSTICK ---------

	TST	FLAG_PRIEM
	BREQ	LOOP1

POV:	CPI	IN_NUM,$05	; -IN
	BRNE	INDSU
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	POV1
	CBI	DDRA,7	; X0=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
POV1:	SBI	DDRA,7	; X0=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0
	
INDSU:	CPI	IN_NUM,$0B	; -IN
	BRNE	KT
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	INDSU1
	CBI	DDRA,7	; X0=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
INDSU1:	SBI	DDRA,7	; X0=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

KT:	CPI	IN_NUM,$06	; KT-IN
	BRNE	BLRED
	CPI	IN_NUM2,$F0	; KT-OUT
	BRNE	KT1
	CBI	DDRA,7	; X0=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY
KT1:	SBI	DDRA,7	; X0=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0

BLRED:	CPI	IN_NUM,$83	; -IN
	BRNE	GRAF
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	BLRED1
	CBI	DDRA,7	; X0=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
BLRED1:	SBI	DDRA,7	; X0=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

GRAF:	CPI	IN_NUM,$09	; -IN
	BRNE	ZAP
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	GRAF1
	CBI	DDRA,7	; X0=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
GRAF1:	SBI	DDRA,7	; X0=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

ZAP:	CPI	IN_NUM,$78	; -IN
	BRNE	STIR
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	ZAP1
	CBI	DDRA,7	; X0=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
ZAP1:	SBI	DDRA,7	; X0=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

STIR:	CPI	IN_NUM,$07	; -IN
	BRNE	SHAG
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	STIR1
	CBI	DDRA,7	; X0=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
STIR1:	SBI	DDRA,7	; X0=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

SHAG:	CPI	IN_NUM,$0A	; -IN
	BRNE	TAB
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	SHAG1
	CBI	DDRA,7	; X0=0
	RJMP	ENDOFKEY
SHAG1:	SBI	DDRA,7	; X0=0
	CBI	PORTA,7	
	RJMP	ENDOFKEY0

TAB:	CPI	IN_NUM,$0D	; -IN
	BRNE	VVOD
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	TAB1
	CBI	DDRA,6	; X1=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
TAB1:	SBI	DDRA,6	; X1=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0

VVOD:	CPI	IN_NUM,$5A	; -IN
	BRNE	SBROS
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	VVOD1
	CBI	DDRA,6	; X1=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
VVOD1:	SBI	DDRA,6	; X1=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

SBROS:	CPI	IN_NUM,$01	; -IN
	BRNE	RUS
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	SBROS1
	CBI	DDRA,6	; X1=0
	CBI	PORTC,3	; Y3=1
	RJMP	ENDOFKEY
SBROS1:	SBI	DDRA,6	; X1=0
	SBI	PORTC,3	; Y3=1
	RJMP	ENDOFKEY0

RUS:	CPI	IN_NUM,$11	; -IN
	BRNE	LAT
	CPI	IN_NUM2,$E0	; -IN
	BRNE	RUS1
	SBI	DDRA,6	; X1=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0
RUS1:	CPI	IN_NUM2,$F0	; -OUT
	BRNE	LAT
	CPI	IN_NUM3,$E0	; -OUT
	BRNE	LAT
	CBI	DDRA,6	; X1=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY

LAT:	CPI	IN_NUM,$11	; -IN
	BRNE	LEFT
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	LAT1
	CBI	DDRA,6	; X1=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
LAT1:	SBI	DDRA,6	; X1=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0	


LEFT:	CPI	IN_NUM,$6B	; -IN
	BRNE	KNE
	CPI	IN_NUM2,$E0	; 
	BRNE	LEFT1
	SBI	DDRA,6	; X1=0
	CBI	PORTA,6	; 
	RJMP	ENDOFKEY0
LEFT1:	CPI	IN_NUM2,$F0	; -OUT
	BRNE	KNE
	CPI	IN_NUM3,$E0	; 
	BRNE	KNE
	CBI	DDRA,6	; X1=1
	RJMP	ENDOFKEY

KNE:	CPI	IN_NUM,$7E	; -IN
	BRNE	VS
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	KNE1
	CBI	DDRA,5	; X2=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
KNE1:	SBI	DDRA,5	; X2=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

VS:	CPI	IN_NUM,$6C	; -IN (HOME)
	BRNE	GT
	CPI	IN_NUM2,$E0	; -IN
	BRNE	VS1
	SBI	DDRA,5	; X2=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0
VS1:	CPI	IN_NUM2,$F0	; -OUT
	BRNE	GT
	CPI	IN_NUM3,$E0	; -OUT
	BRNE	GT
	CBI	DDRA,5	; X2=0
	CBI	PORTC,5	; Y3=1
	RJMP	ENDOFKEY

GT:	CPI	IN_NUM,$69	; -IN
	BRNE	SDVIJ
	CPI	IN_NUM2,$E0
	BRNE	GT1
	SBI	DDRA,5	; X2=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0
GT1:	CPI	IN_NUM2,$F0	; -OUT
	BRNE	SDVIJ
	CPI	IN_NUM3,$E0
	BRNE	SDVIJ
	CBI	DDRA,5	; X2=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY

SDVIJ:	CPI	IN_NUM,$71	; -IN
	BRNE	RAZDV
	CPI	IN_NUM2,$E0
	BRNE	SDVIJ1
	SBI	DDRA,5	; X2=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0
SDVIJ1:	CPI	IN_NUM2,$F0	; -OUT
	BRNE	RAZDV
	CPI	IN_NUM3,$E0
	BRNE	RAZDV
	CBI	DDRA,5	; X2=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY

RAZDV:	CPI	IN_NUM,$70	; -IN (INSERT)
	BREQ	RAZDV2
	CPI	IN_NUM,$04	; -IN
	BRNE	F4
RAZDV2:	CPI	IN_NUM2,$F0	; -OUT
	BRNE	RAZDV1
	CBI	DDRA,5	; X2=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
RAZDV1:	SBI	DDRA,5	; X2=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

F4:	CPI	IN_NUM,$0C	; F4-IN
	BRNE	VPRAVO
	CPI	IN_NUM2,$F0	; F4-OUT
	BRNE	F41
	CBI	DDRA,5	; X2=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
F41:	SBI	DDRA,5	; X2=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

VPRAVO:	CPI	IN_NUM,$74	; -IN
	BRNE	VVERH
	CPI	IN_NUM2,$E0
	BRNE	VPRAVO1
	SBI	DDRA,4	; X3=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0
VPRAVO1: CPI	IN_NUM2,$F0	; -OUT
	BRNE	VVERH
	CPI	IN_NUM3,$E0
	BRNE	VVERH
	CBI	DDRA,4	; X3=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY

VVERH:	CPI	IN_NUM,$75	; -IN
	BRNE	VNIZ
	CPI	IN_NUM2,$E0
	BRNE	VVERH1
	SBI	DDRA,4	; X3=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0
VVERH1: CPI	IN_NUM2,$F0	; -OUT
	BRNE	VNIZ
	CPI	IN_NUM3,$E0
	BRNE	VNIZ
	CBI	DDRA,4	; X3=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY

VNIZ:	CPI	IN_NUM,$72	; -IN
	BRNE	VLVVERH
	CPI	IN_NUM2,$E0
	BRNE	VNIZ1
	SBI	DDRA,4	; X3=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0
VNIZ1:	CPI	IN_NUM2,$F0	; -OUT
	BRNE	VLVVERH
	CPI	IN_NUM3,$E0
	BRNE	VLVVERH
	CBI	DDRA,4	; X3=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY

VLVVERH: CPI	IN_NUM,$6C	; -IN
	BRNE	PROBEL
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	VLVVERH1
	CBI	DDRA,4	; X3=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
VLVVERH1: SBI	DDRA,4	; X3=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

PROBEL: CPI	IN_NUM,$29	; -IN
	BRNE	VPVVERH
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	PROBEL1
	CBI	DDRB,4	; XT15=1
	RJMP	ENDOFKEY
PROBEL1: SBI	DDRB,4	; XT15=0
	RJMP	ENDOFKEY0

VPVVERH: CPI	IN_NUM,$7D	; -IN
	BRNE	VPVNIZ
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	VPVVERH1
	CBI	DDRA,4	; X3=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
VPVVERH1: SBI	DDRA,4	; X3=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

VPVNIZ: CPI	IN_NUM,$7A	; -IN
	BRNE	VLVNIZ
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	VPVNIZ1
	CBI	DDRA,4	; X3=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
VPVNIZ1: SBI	DDRA,4	; X3=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

VLVNIZ: CPI	IN_NUM,$69	; -IN
	BRNE	ZABOY
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	VLVNIZ1
	CBI	DDRA,4	; X3=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
VLVNIZ1: SBI	DDRA,4	; X3=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

ZABOY:	CPI	IN_NUM,$66	; -IN
	BRNE	KL1
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	ZABOY1
	CBI	DDRA,4	; X3=1
	RJMP	ENDOFKEY
ZABOY1:	SBI	DDRA,4	; X3=0
	CBI	PORTA,4	; 
	RJMP	ENDOFKEY0

KL1:	CPI	IN_NUM,$16	; 1-IN
	BRNE	KL2
	CPI	IN_NUM2,$F0	; 1-OUT
	BRNE	KL11
	CBI	DDRA,3	; X4=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
KL11:	SBI	DDRA,3	; X4=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0

KL2:	CPI	IN_NUM,$1E	; 2-IN
	BRNE	KL3
	CPI	IN_NUM2,$F0	; 2-OUT
	BRNE	KL21
	CBI	DDRA,3	; X4=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
KL21:	SBI	DDRA,3	; X4=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

KL3:	CPI	IN_NUM,$26	; 3-IN
	BRNE	KL4
	CPI	IN_NUM2,$F0	; 3-OUT
	BRNE	KL31
	CBI	DDRA,3	; X4=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY
KL31:	SBI	DDRA,3	; X4=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0

KL4:	CPI	IN_NUM,$25	; 4-IN
	BRNE	KL5
	CPI	IN_NUM2,$F0	; 4-OUT
	BRNE	KL41
	CBI	DDRA,3	; X4=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
KL41:	SBI	DDRA,3	; X4=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

KL5:	CPI	IN_NUM,$2E	; 5-IN
	BRNE	KL6
	CPI	IN_NUM2,$F0	; 5-OUT
	BRNE	KL51
	CBI	DDRA,3	; X4=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
KL51:	SBI	DDRA,3	; X4=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

KL6:	CPI	IN_NUM,$36	; 6-IN
	BRNE	KL7
	CPI	IN_NUM2,$F0	; 6-OUT
	BRNE	KL61
	CBI	DDRA,3	; X4=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
KL61:	SBI	DDRA,3	; X4=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

KL7:	CPI	IN_NUM,$3D	; 7-IN
	BRNE	KL0
	CPI	IN_NUM2,$F0	; 7-OUT
	BRNE	KL71
	CBI	DDRA,3	; X4=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
KL71:	SBI	DDRA,3	; X4=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

KL0:	CPI	IN_NUM,$45	; 0-IN
	BRNE	KL9
	CPI	IN_NUM2,$F0	; 0-OUT
	BRNE	KL01
	CBI	DDRA,3	; X4=1
	RJMP	ENDOFKEY
KL01:	SBI	DDRA,3	; X4=0
	CBI	PORTA,3	; 
	RJMP	ENDOFKEY0

KL9:	CPI	IN_NUM,$46	; 9-IN
	BRNE	KLDOT
	CPI	IN_NUM2,$F0	; 9-OUT
	BRNE	KL91
	CBI	DDRA,2	; X5=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
KL91:	SBI	DDRA,2	; X5=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0

KLDOT:	CPI	IN_NUM,$4C	; :-IN
	BRNE	KLDZ
	CPI	IN_NUM2,$F0	; :-OUT
	BRNE	KLDOT1
	CBI	DDRA,2	; X5=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
KLDOT1:	SBI	DDRA,2	; X5=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

KLDZ:	CPI	IN_NUM,$55	; ;-IN
	BRNE	KLZAP
	CPI	IN_NUM2,$F0	; ;-OUT
	BRNE	KLDZ1
	CBI	DDRA,2	; X5=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY
KLDZ1:	SBI	DDRA,2	; X5=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0

KLZAP:	CPI	IN_NUM,$41	; ,-IN
	BRNE	KLMIN
	CPI	IN_NUM2,$F0	; ,-OUT
	BRNE	KLZAP1
	CBI	DDRA,2	; X5=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
KLZAP1:	SBI	DDRA,2	; X5=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

KLMIN:	CPI	IN_NUM,$4E	; --IN
	BRNE	KLPOINT
	CPI	IN_NUM2,$F0	; --OUT
	BRNE	KLMIN1
	CBI	DDRA,2	; X5=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
KLMIN1:	SBI	DDRA,2	; X5=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

KLPOINT: CPI	IN_NUM,$49	; .-IN
	BRNE	KLAPL
	CPI	IN_NUM2,$F0	; .-OUT
	BRNE	KLPOINT1
	CBI	DDRA,2	; X5=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
KLPOINT1: SBI	DDRA,2	; X5=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

KLAPL:	CPI	IN_NUM,$4A	; /-IN
	BRNE	KL8
	CPI	IN_NUM2,$F0	; /-OUT
	BRNE	KLAPL1
	CBI	DDRA,2	; X5=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
KLAPL1:	SBI	DDRA,2	; X5=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

KL8:	CPI	IN_NUM,$3E	; 8-IN
	BRNE	KLA
	CPI	IN_NUM2,$F0	; 8-OUT
	BRNE	KL81
	CBI	DDRA,2	; X5=1
	RJMP	ENDOFKEY
KL81:	SBI	DDRA,2	; X5=0
	CBI	PORTA,2	; 
	RJMP	ENDOFKEY0

KLA:	CPI	IN_NUM,$1C	; A-IN
	BRNE	KLB
	CPI	IN_NUM2,$F0	; A-OUT
	BRNE	KLA1
	CBI	DDRA,1	; X6=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
KLA1:	SBI	DDRA,1	; X6=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0

KLB:	CPI	IN_NUM,$32	; B-IN
	BRNE	KLC
	CPI	IN_NUM2,$F0	; B-OUT
	BRNE	KLB1
	CBI	DDRA,1	; X6=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
KLB1:	SBI	DDRA,1	; X6=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

KLC:	CPI	IN_NUM,$21	; C-IN
	BRNE	KLD
	CPI	IN_NUM2,$F0	; C-OUT
	BRNE	KLC1
	CBI	DDRA,1	; X6=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY
KLC1:	SBI	DDRA,1	; X6=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0

KLD:	CPI	IN_NUM,$23	; D-IN
	BRNE	KLE
	CPI	IN_NUM2,$F0	; D-OUT
	BRNE	KLD1
	CBI	DDRA,1	; X6=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
KLD1:	SBI	DDRA,1	; X6=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

KLE:	CPI	IN_NUM,$24	; E-IN
	BRNE	KLF
	CPI	IN_NUM2,$F0	; E-OUT
	BRNE	KLE1
	CBI	DDRA,1	; X6=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
KLE1:	SBI	DDRA,1	; X6=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

KLF:	CPI	IN_NUM,$2B	; F-IN
	BRNE	KLG
	CPI	IN_NUM2,$F0	; F-OUT
	BRNE	KLF1
	CBI	DDRA,1	; X6=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
KLF1:	SBI	DDRA,1	; X6=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

KLG:	CPI	IN_NUM,$34	; G-IN
	BRNE	KLMAIL
	CPI	IN_NUM2,$F0	; G-OUT
	BRNE	KLG1
	CBI	DDRA,1	; X6=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
KLG1:	SBI	DDRA,1	; X6=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

KLMAIL:	CPI	IN_NUM,$52	; @-IN
	BRNE	KLI
	CPI	IN_NUM2,$F0	; @-OUT
	BRNE	KLMAIL1
	CBI	DDRA,1	; X6=1
	RJMP	ENDOFKEY
KLMAIL1: SBI	DDRA,1	; X6=0
	CBI	PORTA,1	; 
	RJMP	ENDOFKEY0

KLI:	CPI	IN_NUM,$43	; I-IN
	BRNE	KLJ
	CPI	IN_NUM2,$F0	; I-OUT
	BRNE	KLI1
	CBI	DDRA,0	; X7=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
KLI1:	SBI	DDRA,0	; X7=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0

KLJ:	CPI	IN_NUM,$3B	; J-IN
	BRNE	KLK
	CPI	IN_NUM2,$F0	; J-OUT
	BRNE	KLJ1
	CBI	DDRA,0	; X7=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
KLJ1:	SBI	DDRA,0	; X7=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

KLK:	CPI	IN_NUM,$42	; K-IN
	BRNE	KLL
	CPI	IN_NUM2,$F0	; K-OUT
	BRNE	KLK1
	CBI	DDRA,0	; X7=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY
KLK1:	SBI	DDRA,0	; X7=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0

KLL:	CPI	IN_NUM,$4B	; L-IN
	BRNE	KLM
	CPI	IN_NUM2,$F0	; L-OUT
	BRNE	KLL1
	CBI	DDRA,0	; X7=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
KLL1:	SBI	DDRA,0	; X7=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

KLM:	CPI	IN_NUM,$3A	; M-IN
	BRNE	KLN
	CPI	IN_NUM2,$F0	; M-OUT
	BRNE	KLM1
	CBI	DDRA,0	; X7=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
KLM1:	SBI	DDRA,0	; X7=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

KLN:	CPI	IN_NUM,$31	; N-IN
	BRNE	KLO
	CPI	IN_NUM2,$F0	; N-OUT
	BRNE	KLN1
	CBI	DDRA,0	; X7=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
KLN1:	SBI	DDRA,0	; X7=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

KLO:	CPI	IN_NUM,$44	; O-IN
	BRNE	KLH
	CPI	IN_NUM2,$F0	; O-OUT
	BRNE	KLO1
	CBI	DDRA,0	; X7=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
KLO1:	SBI	DDRA,0	; X7=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

KLH:	CPI	IN_NUM,$33	; H-IN
	BRNE	KLQ
	CPI	IN_NUM2,$F0	; H-OUT
	BRNE	KLH1
	CBI	DDRA,0	; X7=1
	RJMP	ENDOFKEY
KLH1:	SBI	DDRA,0	; X7=0
	CBI	PORTA,0	;
	RJMP	ENDOFKEY0

KLQ:	CPI	IN_NUM,$15	; Q-IN
	BRNE	KLR
	CPI	IN_NUM2,$F0	; Q-OUT
	BRNE	KLQ1
	CBI	DDRB,0	; X8=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
KLQ1:	SBI	DDRB,0	; X8=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0

KLR:	CPI	IN_NUM,$2D	; R-IN
	BRNE	KLS
	CPI	IN_NUM2,$F0	; R-OUT
	BRNE	KLR1
	CBI	DDRB,0	; X8=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
KLR1:	SBI	DDRB,0	; X8=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

KLS:	CPI	IN_NUM,$1B	; S-IN
	BRNE	KLT
	CPI	IN_NUM2,$F0	; S-OUT
	BRNE	KLS1
	CBI	DDRB,0	; X8=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY
KLS1:	SBI	DDRB,0	; X8=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0

KLT:	CPI	IN_NUM,$2C	; T-IN
	BRNE	KLU
	CPI	IN_NUM2,$F0	; T-OUT
	BRNE	KLT1
	CBI	DDRB,0	; X8=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
KLT1:	SBI	DDRB,0	; X8=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

KLU:	CPI	IN_NUM,$3C	; U-IN
	BRNE	KLV
	CPI	IN_NUM2,$F0	; U-OUT
	BRNE	KLU1
	CBI	DDRB,0	; X8=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
KLU1:	SBI	DDRB,0	; X8=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

KLV:	CPI	IN_NUM,$2A	; V-IN
	BRNE	KLW
	CPI	IN_NUM2,$F0	; V-OUT
	BRNE	KLV1
	CBI	DDRB,0	; X8=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
KLV1:	SBI	DDRB,0	; X8=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

KLW:	CPI	IN_NUM,$1D	; W-IN
	BRNE	KLP
	CPI	IN_NUM2,$F0	; W-OUT
	BRNE	KLW1
	CBI	DDRB,0	; X8=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY
KLW1:	SBI	DDRB,0	; X8=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0

KLP:	CPI	IN_NUM,$4D	; P-IN
	BRNE	KLY
	CPI	IN_NUM2,$F0	; P-OUT
	BRNE	KLP1
	CBI	DDRB,0	; X8=1
	RJMP	ENDOFKEY
KLP1:	SBI	DDRB,0	; X8=0
	CBI	PORTB,0	;
	RJMP	ENDOFKEY0

KLY:	CPI	IN_NUM,$35	; Y-IN
	BRNE	KLZ
	CPI	IN_NUM2,$F0	; Y-OUT
	BRNE	KLY1
	CBI	DDRB,1	; X9=0
	CBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY
KLY1:	SBI	DDRB,1	; X9=0
	SBI	PORTC,0	; Y1=1
	RJMP	ENDOFKEY0

KLZ:	CPI	IN_NUM,$1A	; Z-IN
	BRNE	KLSS
	CPI	IN_NUM2,$F0	; Z-OUT
	BRNE	KLZ1
	CBI	DDRB,1	; X9=0
	CBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY
KLZ1:	SBI	DDRB,1	; X9=0
	SBI	PORTC,1	; Y2=1
	RJMP	ENDOFKEY0

KLSS:	CPI	IN_NUM,$54	; [-IN
	BRNE	KLAL
	CPI	IN_NUM2,$F0	; [-OUT
	BRNE	KLSS1
	CBI	DDRB,1	; X9=0
	CBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY
KLSS1:	SBI	DDRB,1	; X9=0
	SBI	PORTC,2	; Y3=1
	RJMP	ENDOFKEY0

KLAL:	CPI	IN_NUM,$5D	; \-IN
	BRNE	KLSR
	CPI	IN_NUM2,$F0	; \-OUT
	BRNE	KLAL1
	CBI	DDRB,1	; X9=0
	CBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY
KLAL1:	SBI	DDRB,1	; X9=0
	SBI	PORTC,3	; Y4=1
	RJMP	ENDOFKEY0

KLSR:	CPI	IN_NUM,$5B	; ]-IN
	BRNE	KLCH
	CPI	IN_NUM2,$F0	; ]-OUT
	BRNE	KLSR1
	CBI	DDRB,1	; X9=0
	CBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY
KLSR1:	SBI	DDRB,1	; X9=0
	SBI	PORTC,4	; Y5=1
	RJMP	ENDOFKEY0

KLCH:	CPI	IN_NUM,$0E	; -IN
	BRNE	KLYAT
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	KLCH1
	CBI	DDRB,1	; X9=0
	CBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY
KLCH1:	SBI	DDRB,1	; X9=0
	SBI	PORTC,5	; Y6=1
	RJMP	ENDOFKEY0

KLYAT:	CPI	IN_NUM,$2F	; -IN
	BRNE	KLX
	CPI	IN_NUM2,$E0
	BRNE	KLYAT1
	SBI	DDRB,1	; X9=0
	SBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY0
KLYAT1: CPI	IN_NUM2,$F0	; -OUT
	BRNE	KLX
	CPI	IN_NUM3,$E0
	BRNE	KLX
	CBI	DDRB,1	; X9=0
	CBI	PORTC,6	; Y7=1
	RJMP	ENDOFKEY

KLX:	CPI	IN_NUM,$22	; X-IN
	BRNE	KLESC
	CPI	IN_NUM2,$F0	; X-OUT
	BRNE	KLX1
	CBI	DDRB,1	; X9=1
	RJMP	ENDOFKEY
KLX1:	SBI	DDRB,1	; X9=0
	CBI	PORTB,1	;
	RJMP	ENDOFKEY0

KLESC:	CPI	IN_NUM,$76	; -IN
	BRNE	KLSU
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	KLESC1
	;;;;SBI	PORTD,4		; CBI	DDRD,4	; XT2.14=1
	CBI	PORTD,5	; XT2.15=0
	RJMP	ENDOFKEY
KLESC1:	;;;CBI	PORTD,4		;SBI	DDRD,4	; XT2.14=0
	SBI	PORTD,5	; XT2.15=1
	RJMP	ENDOFKEY0 

KLSU:	CPI	IN_NUM,$14	; -IN
	BRNE	KLZAG
	CPI	IN_NUM2,$F0	; -OUT
	BRNE	KLSU1
	CBI	DDRC,7	; XT2.9=1
	RJMP	ENDOFKEY
KLSU1:	SBI	DDRC,7	; XT2.9=0
	CBI	PORTC,7	;
	RJMP	ENDOFKEY0 

KLZAG:	CPI	IN_NUM,$58	; /-IN
	BRNE	KLAR2
	CPI	IN_NUM2,$F0	; /-OUT
	BRNE	KLZAG1
	TST	ZAGL
	BRNE	KLZAG2
	CBI	DDRB,3	; XT1.13=1
	RJMP	ENDOFKEY
KLZAG2:	CBI	DDRB,2	; XT1.13=1
	RJMP	ENDOFKEY
KLZAG1:	TST	ZAGL
	BRNE	KLZAG3
	SBI	DDRB,2	; XT1.13=0
	CBI	PORTB,2
	INC	ZAGL
	RJMP	ENDOFKEY0
KLZAG3:	SBI	DDRB,3	; XT1.13=0
	CBI	PORTB,3
	CLR	ZAGL
	RJMP	ENDOFKEY0 

KLAR2:	CPI	IN_NUM,$1F	; 2-IN
	BREQ	KLAR3
	CPI	IN_NUM,$27	; 2-IN
	BRNE	KLSHIFT
KLAR3:	CPI	IN_NUM2,$F0	; 2-OUT
	BRNE	KLAR21
	CBI	DDRD,6	; XT2.10=1
	RJMP	ENDOFKEY
KLAR21:	SBI	DDRD,6	; XT2.10=0
	CBI	PORTD,6	;
	RJMP	ENDOFKEY0

KLSHIFT: CPI	IN_NUM,$12	; -IN
	BREQ	KLSHIFT3
	CPI	IN_NUM,$59	;
	BRNE	KLPAUS
KLSHIFT3: CPI	IN_NUM2,$F0	; -OUT
	BRNE	KLSHIFT21
	CBI	DDRD,7	; XT2.11=1
	RJMP	ENDOFKEY
KLSHIFT21: SBI	DDRD,7	; XT2.11=0
	CBI	PORTD,7	;
	RJMP	ENDOFKEY0

KLPAUS:	CPI	IN_NUM,$7C	; RESET
	BRNE	ENDOFKEY
	RJMP	RESET

ENDOFKEY0: CLR	BUF
	STS TL3,BUF

ENDOFKEY: 
	CLR	FLAG_PRIEM
	LDI	BUF,0b11000000	;  -  INT0, INT1!
	OUT	GICR,BUF
	RJMP 	loop1

